// Copyright Howard Hinnant 2007-2010. Distributed under the Boost
// Software License, Version 1.0. (see http://www.boost.org/LICENSE_1_0.txt)

#ifndef TN_SHARED_MUTEX_H_
#define TN_SHARED_MUTEX_H_

#if (defined(TN_PLATFORM_WINPHONE) || defined(TN_PLATFORM_WINRT))

#include <mutex>
#include <condition_variable>
#include <chrono>
#include <climits>
#include <system_error>

namespace Tn
{
	namespace Foundation
	{

class shared_mutex
{
    typedef std::mutex              mutex_t;
    typedef std::condition_variable cond_t;
    typedef unsigned                count_t;

    mutex_t mut_;
    cond_t  gate1_;
    cond_t  gate2_;
    count_t state_;

    static const unsigned write_entered_ = 1U << (sizeof(count_t)*CHAR_BIT - 1);
    static const unsigned upgradable_entered_ = write_entered_ >> 1;
    static const unsigned n_readers_ = ~(write_entered_ | upgradable_entered_);

public:

    shared_mutex() : gate1_(), gate2_(), state_(0) {}
    ~shared_mutex()
    {
        std::lock_guard<mutex_t> _(mut_);
    }

private:
    shared_mutex(const shared_mutex&) {}
    shared_mutex& operator=(const shared_mutex&) { return *this; }

public:
// Exclusive ownership

    void lock()
    {
        std::unique_lock<mutex_t> lk(mut_);
        while (state_ & (write_entered_ | upgradable_entered_))
            gate1_.wait(lk);
        state_ |= write_entered_;
        while (state_ & n_readers_)
            gate2_.wait(lk);
    }

    bool try_lock()
    {
        std::unique_lock<mutex_t> lk(mut_);
        if (state_ == 0)
        {
            state_ = write_entered_;
            return true;
        }
        return false;
    }    

    template <class Rep, class Period>
        bool try_lock_for(const std::chrono::duration<Rep, Period>& rel_time)
        {
            return try_lock_until(std::chrono::steady_clock::now() + rel_time);
        }
    template <class Clock, class Duration>
        bool
        try_lock_until(const std::chrono::time_point<Clock, Duration>& abs_time);

    void unlock()
    {
        std::lock_guard<mutex_t> _(mut_);
        state_ = 0;
        gate1_.notify_all();
    }    

// Shared ownership

    void lock_shared()
    {
        std::unique_lock<mutex_t> lk(mut_);
        while ((state_ & write_entered_) || (state_ & n_readers_) == n_readers_)
            gate1_.wait(lk);
        count_t num_readers = (state_ & n_readers_) + 1;
        state_ &= ~n_readers_;
        state_ |= num_readers;
    }    

    bool try_lock_shared()
    {
        std::unique_lock<mutex_t> lk(mut_);
        count_t num_readers = state_ & n_readers_;
        if (!(state_ & write_entered_) && num_readers != n_readers_)
        {
            ++num_readers;
            state_ &= ~n_readers_;
            state_ |= num_readers;
            return true;
        }
        return false;
    }

    template <class Rep, class Period>
        bool
        try_lock_shared_for(const std::chrono::duration<Rep, Period>& rel_time)
        {
            return try_lock_shared_until(std::chrono::steady_clock::now() +
                                         rel_time);
        }
    template <class Clock, class Duration>
        bool
        try_lock_shared_until(const std::chrono::time_point<Clock, Duration>& abs_time);

    void unlock_shared()
    {
        std::lock_guard<mutex_t> _(mut_);
        count_t num_readers = (state_ & n_readers_) - 1;
        state_ &= ~n_readers_;
        state_ |= num_readers;
        if (state_ & write_entered_)
        {
            if (num_readers == 0)
                gate2_.notify_one();
        }
        else
        {
            if (num_readers == n_readers_ - 1)
                gate1_.notify_one();
        }
    }    

// Upgrade ownership

    void lock_upgrade()
    {
        std::unique_lock<mutex_t> lk(mut_);
        while ((state_ & (write_entered_ | upgradable_entered_)) || 
               (state_ & n_readers_) == n_readers_)
            gate1_.wait(lk);
        count_t num_readers = (state_ & n_readers_) + 1;
        state_ &= ~n_readers_;
        state_ |= upgradable_entered_ | num_readers;
    }

    bool try_lock_upgrade()
    {
        std::unique_lock<mutex_t> lk(mut_);
        count_t num_readers = state_ & n_readers_;
        if (!(state_ & (write_entered_ | upgradable_entered_))
            && num_readers != n_readers_)
        {
            ++num_readers;
            state_ &= ~n_readers_;
            state_ |= upgradable_entered_ | num_readers;
            return true;
        }
        return false;
    }

    template <class Rep, class Period>
        bool
        try_lock_upgrade_for(
                            const std::chrono::duration<Rep, Period>& rel_time)
        {
            return try_lock_upgrade_until(std::chrono::steady_clock::now() +
                                         rel_time);
        }
    template <class Clock, class Duration>
        bool
        try_lock_upgrade_until(
                      const std::chrono::time_point<Clock, Duration>& abs_time);
    
    void unlock_upgrade()
    {
        {
            std::lock_guard<mutex_t> _(mut_);
            count_t num_readers = (state_ & n_readers_) - 1;
            state_ &= ~(upgradable_entered_ | n_readers_);
            state_ |= num_readers;
        }
        gate1_.notify_all();
    }    

// Shared <-> Exclusive

    bool try_unlock_shared_and_lock()
    {
        std::unique_lock<mutex_t> lk(mut_);
        if (state_ == 1)
        {
            state_ = write_entered_;
            return true;
        }
        return false;
    }

    template <class Rep, class Period>
        bool
        try_unlock_shared_and_lock_for(
                            const std::chrono::duration<Rep, Period>& rel_time)
        {
            return try_unlock_shared_and_lock_until(
                                   std::chrono::steady_clock::now() + rel_time);
        }
    template <class Clock, class Duration>
        bool
        try_unlock_shared_and_lock_until(
                      const std::chrono::time_point<Clock, Duration>& abs_time);

    void unlock_and_lock_shared()
    {
        {
            std::lock_guard<mutex_t> _(mut_);
            state_ = 1;
        }
        gate1_.notify_all();
    }    

// Shared <-> Upgrade

    bool try_unlock_shared_and_lock_upgrade()
    {
        std::unique_lock<mutex_t> lk(mut_);
        if (!(state_ & (write_entered_ | upgradable_entered_)))
        {
            state_ |= upgradable_entered_;
            return true;
        }
        return false;
    }

    template <class Rep, class Period>
        bool
        try_unlock_shared_and_lock_upgrade_for(
                            const std::chrono::duration<Rep, Period>& rel_time)
        {
            return try_unlock_shared_and_lock_upgrade_until(
                                   std::chrono::steady_clock::now() + rel_time);
        }
    template <class Clock, class Duration>
        bool
        try_unlock_shared_and_lock_upgrade_until(
                      const std::chrono::time_point<Clock, Duration>& abs_time);

    void unlock_upgrade_and_lock_shared()
    {
        {
            std::lock_guard<mutex_t> _(mut_);
            state_ &= ~upgradable_entered_;
        }
        gate1_.notify_all();
    }    

// Upgrade <-> Exclusive

    void unlock_upgrade_and_lock()
    {
        std::unique_lock<mutex_t> lk(mut_);
        count_t num_readers = (state_ & n_readers_) - 1;
        state_ &= ~(upgradable_entered_ | n_readers_);
        state_ |= write_entered_ | num_readers;
        while (state_ & n_readers_)
            gate2_.wait(lk);
    }

    bool try_unlock_upgrade_and_lock()
    {
        std::unique_lock<mutex_t> lk(mut_);
        if (state_ == (upgradable_entered_ | 1))
        {
            state_ = write_entered_;
            return true;
        }
        return false;
    }

    template <class Rep, class Period>
        bool
        try_unlock_upgrade_and_lock_for(
                            const std::chrono::duration<Rep, Period>& rel_time)
        {
            return try_unlock_upgrade_and_lock_until(
                                   std::chrono::steady_clock::now() + rel_time);
        }
    template <class Clock, class Duration>
        bool
        try_unlock_upgrade_and_lock_until(
                      const std::chrono::time_point<Clock, Duration>& abs_time);

    void unlock_and_lock_upgrade()
    {
        {
            std::lock_guard<mutex_t> _(mut_);
            state_ = upgradable_entered_ | 1;
        }
        gate1_.notify_all();
    }    
};

template <class Clock, class Duration>
bool
shared_mutex::try_lock_until(
                       const std::chrono::time_point<Clock, Duration>& abs_time)
{
    std::unique_lock<mutex_t> lk(mut_);
    if (state_ & (write_entered_ | upgradable_entered_))
    {
        while (true)
        {
            std::cv_status status = gate1_.wait_until(lk, abs_time);
            if ((state_ & (write_entered_ | upgradable_entered_)) == 0)
                break;
            if (status == std::cv_status::timeout)
                return false;
        }
    }
    state_ |= write_entered_;
    if (state_ & n_readers_)
    {
        while (true)
        {
            std::cv_status status = gate2_.wait_until(lk, abs_time);
            if ((state_ & n_readers_) == 0)
                break;
            if (status == std::cv_status::timeout)
            {
                state_ &= ~write_entered_;
                return false;
            }
        }
    }
    return true;
}

template <class Clock, class Duration>
bool
shared_mutex::try_lock_shared_until(
                       const std::chrono::time_point<Clock, Duration>& abs_time)
{
    std::unique_lock<mutex_t> lk(mut_);
    if ((state_ & write_entered_) || (state_ & n_readers_) == n_readers_)
    {
        while (true)
        {
            std::cv_status status = gate1_.wait_until(lk, abs_time);
            if ((state_ & write_entered_) == 0 &&
                                             (state_ & n_readers_) < n_readers_)
                break;
            if (status == std::cv_status::timeout)
                return false;
        }
    }
    count_t num_readers = (state_ & n_readers_) + 1;
    state_ &= ~n_readers_;
    state_ |= num_readers;
    return true;
}

template <class Clock, class Duration>
bool
shared_mutex::try_lock_upgrade_until(
                       const std::chrono::time_point<Clock, Duration>& abs_time)
{
    std::unique_lock<mutex_t> lk(mut_);
    if ((state_ & (write_entered_ | upgradable_entered_)) ||
        (state_ & n_readers_) == n_readers_)
    {
        while (true)
        {
            std::cv_status status = gate1_.wait_until(lk, abs_time);
            if ((state_ & (write_entered_ | upgradable_entered_)) == 0 &&
                                             (state_ & n_readers_) < n_readers_)
                break;
            if (status == std::cv_status::timeout)
                return false;
        }
    }
    count_t num_readers = (state_ & n_readers_) + 1;
    state_ &= ~n_readers_;
    state_ |= upgradable_entered_ | num_readers;
    return true;
}

template <class Clock, class Duration>
bool
shared_mutex::try_unlock_shared_and_lock_until(
                       const std::chrono::time_point<Clock, Duration>& abs_time)
{
    std::unique_lock<mutex_t> lk(mut_);
    if (state_ != 1)
    {
        while (true)
        {
            std::cv_status status = gate2_.wait_until(lk, abs_time);
            if (state_ == 1)
                break;
            if (status == std::cv_status::timeout)
                return false;
        }
    }
    state_ = write_entered_;
    return true;
}

template <class Clock, class Duration>
bool
shared_mutex::try_unlock_shared_and_lock_upgrade_until(
                       const std::chrono::time_point<Clock, Duration>& abs_time)
{
    std::unique_lock<mutex_t> lk(mut_);
    if ((state_ & (write_entered_ | upgradable_entered_)) != 0)
    {
        while (true)
        {
            std::cv_status status = gate2_.wait_until(lk, abs_time);
            if ((state_ & (write_entered_ | upgradable_entered_)) == 0)
                break;
            if (status == std::cv_status::timeout)
                return false;
        }
    }
    state_ |= upgradable_entered_;
    return true;
}

template <class Clock, class Duration>
bool
shared_mutex::try_unlock_upgrade_and_lock_until(
                       const std::chrono::time_point<Clock, Duration>& abs_time)
{
    std::unique_lock<mutex_t> lk(mut_);
    if ((state_ & n_readers_) != 1)
    {
        while (true)
        {
            std::cv_status status = gate2_.wait_until(lk, abs_time);
            if ((state_ & n_readers_) == 1)
                break;
            if (status == std::cv_status::timeout)
                return false;
        }
    }
    state_ = write_entered_;
    return true;
}

template <class Mutex> class upgrade_lock;

template <class Mutex>
class shared_lock
{
public:
    typedef Mutex mutex_type;

private:
    mutex_type* m_;
    bool owns_;

    struct __nat {int _;};

public:
    shared_lock()
        : m_(nullptr), owns_(false) {}

    explicit shared_lock(mutex_type& m)
        : m_(&m), owns_(true)
        {m_->lock_shared();}

    shared_lock(mutex_type& m, std::defer_lock_t)
        : m_(&m), owns_(false) {}

    shared_lock(mutex_type& m, std::try_to_lock_t)
        : m_(&m), owns_(m.try_lock_shared()) {}

    shared_lock(mutex_type& m, std::adopt_lock_t)
        : m_(&m), owns_(true) {}

    template <class Clock, class Duration>
        shared_lock(mutex_type& m,
                    const std::chrono::time_point<Clock, Duration>& abs_time)
        : m_(&m), owns_(m.try_lock_shared_until(abs_time)) {}
    template <class Rep, class Period>
        shared_lock(mutex_type& m,
                    const std::chrono::duration<Rep, Period>& rel_time)
        : m_(&m), owns_(m.try_lock_shared_for(rel_time)) {}

    ~shared_lock()
    {
        if (owns_)
            m_->unlock_shared();
    }

private:
    shared_lock(shared_lock const&) {}
    shared_lock& operator=(shared_lock const&) {return *this; }

public:
    shared_lock(shared_lock&& sl)
        : m_(sl.m_), owns_(sl.owns_)
        {sl.m_ = nullptr; sl.owns_ = false;}

    shared_lock& operator=(shared_lock&& sl)
    {
        if (owns_)
            m_->unlock_shared();
        m_ = sl.m_;
        owns_ = sl.owns_;
        sl.m_ = nullptr;
        sl.owns_ = false;
        return *this;
    }

    explicit shared_lock(upgrade_lock<mutex_type>&& ul)
        : m_(ul.mutex()), owns_(ul.owns_lock())
    {
        if (owns_)
            m_->unlock_upgrade_and_lock_shared();
        ul.release();
    }

    explicit shared_lock(std::unique_lock<mutex_type>&& ul)
        : m_(ul.mutex()), owns_(ul.owns_lock())
    {
        if (owns_)
            m_->unlock_and_lock_shared();
        ul.release();
    }

    void lock();
    bool try_lock();
    template <class Rep, class Period>
        bool try_lock_for(const std::chrono::duration<Rep, Period>& rel_time)
        {
            return try_lock_until(std::chrono::steady_clock::now() + rel_time);
        }
    template <class Clock, class Duration>
        bool
        try_lock_until(
                      const std::chrono::time_point<Clock, Duration>& abs_time);
    void unlock();

    void swap(shared_lock&& u)
    {
        std::swap(m_, u.m_);
        std::swap(owns_, u.owns_);
    }

    mutex_type* release()
    {
        mutex_type* r = m_;
        m_ = nullptr;
        owns_ = false;
        return r;
    }
    bool owns_lock() const {return owns_;}
    operator int __nat::* () const {return owns_ ? &__nat::_ : 0;}
    mutex_type* mutex() const {return m_;}

};

template <class Mutex>
void
shared_lock<Mutex>::lock()
{
    if (m_ == nullptr)
        throw std::system_error(std::error_code(EPERM, std::system_category()),
                                    "shared_lock::lock: references null mutex");
    if (owns_)
        throw std::system_error(std::error_code(EDEADLK, std::system_category()),
                                           "shared_lock::lock: already locked");
    m_->lock_shared();
    owns_ = true;
}

template <class Mutex>
bool
shared_lock<Mutex>::try_lock()
{
    if (m_ == nullptr)
        throw std::system_error(std::error_code(EPERM, std::system_category()),
                                "shared_lock::try_lock: references null mutex");
    if (owns_)
        throw std::system_error(std::error_code(EDEADLK, std::system_category()),
                                       "shared_lock::try_lock: already locked");
    owns_ = m_->try_lock_shared();
    return owns_;
}

template <class Mutex>
template <class Clock, class Duration>
bool
shared_lock<Mutex>::try_lock_until(
                       const std::chrono::time_point<Clock, Duration>& abs_time)
{
    if (m_ == nullptr)
        throw std::system_error(std::error_code(EPERM, std::system_category()),
                          "shared_lock::try_lock_until: references null mutex");
    if (owns_)
        throw std::system_error(std::error_code(EDEADLK, std::system_category()),
                                 "shared_lock::try_lock_until: already locked");
    owns_ = m_->try_lock_shared_until(abs_time);
    return owns_;
}

template <class Mutex>
void
shared_lock<Mutex>::unlock()
{
    if (!owns_)
        throw std::system_error(std::error_code(EPERM, std::system_category()),
                                "shared_lock::unlock: not locked");
    m_->unlock_shared();
    owns_ = false;
}

template <class Mutex>
inline
void
swap(shared_lock<Mutex>&  x, shared_lock<Mutex>&  y)
{
    x.swap(y);
}

template <class Mutex>
class upgrade_lock
{
public:
    typedef Mutex mutex_type;

private:
    mutex_type* m_;
    bool owns_;

    struct __nat {int _;};

public:
    upgrade_lock()
        : m_(nullptr), owns_(false) {}

    explicit upgrade_lock(mutex_type& m)
        : m_(&m), owns_(true)
        {m_->lock_upgrade();}

    upgrade_lock(mutex_type& m, std::defer_lock_t)
        : m_(&m), owns_(false) {}

    upgrade_lock(mutex_type& m, std::try_to_lock_t)
        : m_(&m), owns_(m.try_lock_upgrade()) {}

    upgrade_lock(mutex_type& m, std::adopt_lock_t)
        : m_(&m), owns_(true) {}

    template <class Clock, class Duration>
        upgrade_lock(mutex_type& m,
                    const std::chrono::time_point<Clock, Duration>& abs_time)
        : m_(&m), owns_(m.try_lock_upgrade_until(abs_time)) {}
    template <class Rep, class Period>
        upgrade_lock(mutex_type& m,
                    const std::chrono::duration<Rep, Period>& rel_time)
        : m_(&m), owns_(m.try_lock_upgrade_for(rel_time)) {}

    ~upgrade_lock()
    {
        if (owns_)
            m_->unlock_upgrade();
    }

private:
    upgrade_lock(upgrade_lock const&) {}
    upgrade_lock& operator=(upgrade_lock const&) { return *this; }

public:
    upgrade_lock(upgrade_lock&& ul)
        : m_(ul.m_), owns_(ul.owns_)
        {
            ul.m_ = nullptr;
            ul.owns_ = false;
        }

    upgrade_lock& operator=(upgrade_lock&& ul)
    {
        if (owns_)
            m_->unlock_upgrade();
        m_ = ul.m_;
        owns_ = ul.owns_;
        ul.m_ = nullptr;
        ul.owns_ = false;
        return *this;
    }

    upgrade_lock(shared_lock<mutex_type>&& sl, std::try_to_lock_t)
        : m_(nullptr), owns_(false)
    {
        if (sl.owns_lock())
        {
            if (sl.mutex()->try_unlock_shared_and_lock_upgrade())
            {
                m_ = sl.release();
                owns_ = true;
            }
        }
        else
            m_ = sl.release();
    }

    template <class Clock, class Duration>
        upgrade_lock(shared_lock<mutex_type>&& sl,
                     const std::chrono::time_point<Clock, Duration>& abs_time)
        : m_(nullptr), owns_(false)
    {
        if (sl.owns_lock())
        {
            if (sl.mutex()->try_unlock_shared_and_lock_upgrade_until(abs_time))
            {
                m_ = sl.release();
                owns_ = true;
            }
        }
        else
            m_ = sl.release();
    }

    template <class Rep, class Period>
        upgrade_lock(shared_lock<mutex_type>&& sl,
                     const std::chrono::duration<Rep, Period>& rel_time)
        : m_(nullptr), owns_(false)
    {
        if (sl.owns_lock())
        {
            if (sl.mutex()->try_unlock_shared_and_lock_upgrade_for(rel_time))
            {
                m_ = sl.release();
                owns_ = true;
            }
        }
        else
            m_ = sl.release();
    }

    explicit upgrade_lock(std::unique_lock<mutex_type>&& ul)
        : m_(ul.mutex()), owns_(ul.owns_lock())
    {
        if (owns_)
            m_->unlock_and_lock_upgrade();
        ul.release();
    }

    void lock();
    bool try_lock();
    template <class Rep, class Period>
        bool try_lock_for(const std::chrono::duration<Rep, Period>& rel_time)
        {
            return try_lock_until(std::chrono::steady_clock::now() + rel_time);
        }
    template <class Clock, class Duration>
        bool
        try_lock_until(
                      const std::chrono::time_point<Clock, Duration>& abs_time);
    void unlock();

    void swap(upgrade_lock&& u)
    {
        std::swap(m_, u.m_);
        std::swap(owns_, u.owns_);
    }

    mutex_type* release()
    {
        mutex_type* r = m_;
        m_ = 0;
        owns_ = false;
        return r;
    }

    bool owns_lock() const {return owns_;}
    operator int __nat::* () const {return owns_ ? &__nat::_ : 0;}
    mutex_type* mutex() const {return m_;}
};

template <class Mutex>
void
upgrade_lock<Mutex>::lock()
{
    if (m_ == nullptr)
        throw std::system_error(std::error_code(EPERM, std::system_category()),
                                   "upgrade_lock::lock: references null mutex");
    if (owns_)
        throw std::system_error(std::error_code(EDEADLK, std::system_category()),
                                          "upgrade_lock::lock: already locked");
    m_->lock_upgrade();
    owns_ = true;
}

template <class Mutex>
bool
upgrade_lock<Mutex>::try_lock()
{
    if (m_ == nullptr)
        throw std::system_error(std::error_code(EPERM, std::system_category()),
                               "upgrade_lock::try_lock: references null mutex");
    if (owns_)
        throw std::system_error(std::error_code(EDEADLK, std::system_category()),
                                      "upgrade_lock::try_lock: already locked");
    owns_ = m_->try_lock_upgrade();
    return owns_;
}

template <class Mutex>
template <class Clock, class Duration>
bool
upgrade_lock<Mutex>::try_lock_until(
                       const std::chrono::time_point<Clock, Duration>& abs_time)
{
    if (m_ == nullptr)
        throw std::system_error(std::error_code(EPERM, std::system_category()),
                         "upgrade_lock::try_lock_until: references null mutex");
    if (owns_)
        throw std::system_error(std::error_code(EDEADLK, std::system_category()),
                                "upgrade_lock::try_lock_until: already locked");
    owns_ = m_->try_lock_upgrade_until(abs_time);
    return owns_;
}

template <class Mutex>
void
upgrade_lock<Mutex>::unlock()
{
    if (!owns_)
        throw std::system_error(std::error_code(EPERM, std::system_category()),
                                "upgrade_lock::unlock: not locked");
    m_->unlock_upgrade();
    owns_ = false;
}

template <class Mutex>
inline
void
swap(upgrade_lock<Mutex>&  x, upgrade_lock<Mutex>&  y)
{
    x.swap(y);
}


template <class Mutex>
class upgrade_to_unique_lock
{
public:
    typedef Mutex mutex_type;

private:
    upgrade_lock<Mutex>* ul_;
    mutex_type* m_;
    bool owns_;

public:
    explicit upgrade_to_unique_lock(upgrade_lock<Mutex>& ul)
    : ul_(&ul), m_(ul.mutex()), owns_(ul.owns_lock())
    {
        if (owns_)
            m_->unlock_upgrade_and_lock();
    }

    ~upgrade_to_unique_lock()
    {
        if (owns_)
            m_->unlock_and_lock_upgrade();
    }

private:
    upgrade_to_unique_lock(upgrade_to_unique_lock const& other) {}
    upgrade_to_unique_lock& operator=(upgrade_to_unique_lock<Mutex> const& other) { return *this; }

public:
    upgrade_to_unique_lock(upgrade_to_unique_lock<Mutex> && other)
    : ul_(other.ul_), m_(other.m_), owns_(other.owns_)
    {
        other.ul_ = nullptr;
        other.m_ = nullptr;
        other.owns_ = false;
    }

    upgrade_to_unique_lock& operator=(upgrade_to_unique_lock<Mutex> && other)
    {
        if (owns_)
            m_->unlock_and_lock_upgrade();

        ul_ = other.ul_;
        m_ = other.m_;
        owns_ = other.owns_;

        other.ul_ = nullptr;
        other.m_ = nullptr;
        other.owns_ = false;
    }

    void swap(upgrade_to_unique_lock<Mutex>& other)
    {
        std::swap(ul_, other.ul_);
        std::swap(m_, other.m_);
        std::swap(owns_, other.owns_);
    }

    bool owns_lock() const { return owns_; }    
};


template <class Mutex>
inline
void
swap(upgrade_to_unique_lock<Mutex>&  x, upgrade_to_unique_lock<Mutex>&  y)
{
    x.swap(y);
}

    }   // namespace Foundation
}  // namespace Tn


#else     //!(defined(TN_PLATFORM_WINPHONE) || defined(TN_PLATFORM_WINRT))
#include <foundation/Mutex.h>
#endif    //!(defined(TN_PLATFORM_WINPHONE) || defined(TN_PLATFORM_WINRT))

#endif    //!__TN_SHARED_MUTEX_H_